#ifndef BITTORRENT_SEARCH
#define BITTORRENT_SEARCH

#include <qstring.h>
#include <qobject.h>
#include <qnetworkprotocol.h>
#include <qvaluelist.h>
#include <qpair.h>
class QUrlOperator;

typedef QPair< QStringList, QValueList< QPair< QString, QString > > > TORRENTS;

class BitTorrentSearch : public QObject
{
	Q_OBJECT
public:
	BitTorrentSearch( const QString& query, const QString& searchid );
	~BitTorrentSearch();
	void start();
	QValueList< TORRENTS > getTorrents();

protected:
	TORRENTS decode( const QString& );
	QUrlOperator* _op;
	QString _data;
	QValueList< TORRENTS > _torrents;
	QString _query;
	QString _searchid;

signals:
	void finished( const QString& );

private slots:
	void btFinished( QNetworkOperation* n );
	void btData( const QByteArray& b, QNetworkOperation* n );
};

#endif
