#ifndef MESSENGERCONTACTS_H
#define MESSENGERCONTACTS_H
#include "BMessengerContacts.h"
#include "Messenger.h"
#include <qstring.h>
#include <qptrlist.h>

class MessengerThread;
class MessengerLogin;
class MessengerStatus;

class MessengerContacts : public BMessengerContacts
{
    Q_OBJECT

public:
    MessengerContacts( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~MessengerContacts();
	void addContact( const QString& yid, const QString& group, const QString& status );
	void updateContact( const QString& yid, int status, const QString& msg );
	void init( const QString& yid, const QString& passwd, bool invisible = false );
	static void connected( int id );
	static void connectError();
	static MessengerContacts* instance();
	void receivedMessage( char* from, char* msg );
	
private slots:
	void connectYh();
	void disconnectYh();
	virtual void slotItemSelected( QListViewItem* );
	virtual void slotChangeStatus();
	
protected:
	static int _id;
	static MessengerContacts* _instance;
	QString _user;
	QString _passwd;
	static bool _invisible;
	MessengerThread* _messenger_thread;
	MessengerLogin* _ml;
	MessengerStatus* _mstatus;
	QPtrList< Messenger > _messengers;
};

#endif // MESSENGERCONTACTS_H
