#ifndef SEARCHVIEWITEM_H
#define SEARCHVIEWITEM_H

#include <qlistview.h>
#include <qstring.h>

class Connections;

class SearchViewItem : public QListViewItem
{
public:
	SearchViewItem( QListView *parent, Connections* connections );
	SearchViewItem( QListView *parent, Connections* connections, QListViewItem *after );
	SearchViewItem( QListViewItem *parent, Connections* connections, QListView* search_list );
  
	/* 
		a = column 0,
		b = column 2,
		c = column 3,
		...
	*/
	SearchViewItem( QListView* parent, Connections* connections, const QString& a, const QString& b,
		const QString& c, const QString& d, const QString& e, const QString& f, const QString& g );
	SearchViewItem( QListView *parent, Connections* connections, QListViewItem *after, const QString& a,
		const QString& b, const QString& c, const QString& d, const QString& e, const QString& f, const QString& g );
	SearchViewItem( QListViewItem *parent, Connections* connections, QListView* search_list, const QString& a,
		const QString& b, const QString& c, const QString& d, const QString& e, const QString& f, const QString& g );

#if QT_VERSION >= 300
	virtual int compare( QListViewItem* item, int column, bool ascending ) const;
#else
	virtual QString key(int column, bool ascending) const;
#endif

	bool _group_parent;

	const void setData( const QString&, const QString&, const QString&, const QString&, const QString&, const QString&, const QString& );
	const void setState( const Q_UINT32 speed, const int state );

private:
	Connections* _connections;
	QListView* _parent;

public:
	int _hit_counter;
	unsigned long _size;
	QString _filename_original;
	QString _filename_lower;
	QString _type;
	QString _address;
	QString _agent;
	QString _info;
	int _speed;
	int _state;
};

#endif
